// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from bond:msg/Status.idl
// generated code does not contain a copyright notice
#include "bond/msg/detail/status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `id`
// Member `instance_id`
#include "rosidl_runtime_c/string_functions.h"

bool
bond__msg__Status__init(bond__msg__Status * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    bond__msg__Status__fini(msg);
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__init(&msg->id)) {
    bond__msg__Status__fini(msg);
    return false;
  }
  // instance_id
  if (!rosidl_runtime_c__String__init(&msg->instance_id)) {
    bond__msg__Status__fini(msg);
    return false;
  }
  // active
  // heartbeat_timeout
  // heartbeat_period
  return true;
}

void
bond__msg__Status__fini(bond__msg__Status * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // id
  rosidl_runtime_c__String__fini(&msg->id);
  // instance_id
  rosidl_runtime_c__String__fini(&msg->instance_id);
  // active
  // heartbeat_timeout
  // heartbeat_period
}

bond__msg__Status *
bond__msg__Status__create()
{
  bond__msg__Status * msg = (bond__msg__Status *)malloc(sizeof(bond__msg__Status));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(bond__msg__Status));
  bool success = bond__msg__Status__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
bond__msg__Status__destroy(bond__msg__Status * msg)
{
  if (msg) {
    bond__msg__Status__fini(msg);
  }
  free(msg);
}


bool
bond__msg__Status__Sequence__init(bond__msg__Status__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  bond__msg__Status * data = NULL;
  if (size) {
    data = (bond__msg__Status *)calloc(size, sizeof(bond__msg__Status));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = bond__msg__Status__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        bond__msg__Status__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
bond__msg__Status__Sequence__fini(bond__msg__Status__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      bond__msg__Status__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

bond__msg__Status__Sequence *
bond__msg__Status__Sequence__create(size_t size)
{
  bond__msg__Status__Sequence * array = (bond__msg__Status__Sequence *)malloc(sizeof(bond__msg__Status__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = bond__msg__Status__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
bond__msg__Status__Sequence__destroy(bond__msg__Status__Sequence * array)
{
  if (array) {
    bond__msg__Status__Sequence__fini(array);
  }
  free(array);
}
